Index: lemon/maps.h
===================================================================
--- lemon/maps.h	(revision 280)
+++ lemon/maps.h	(revision 301)
@@ -74,7 +74,7 @@
   };
 
-  /// Returns a \ref NullMap class
-
-  /// This function just returns a \ref NullMap class.
+  /// Returns a \c NullMap class
+
+  /// This function just returns a \c NullMap class.
   /// \relates NullMap
   template <typename K, typename V>
@@ -89,5 +89,5 @@
   /// value to each key.
   ///
-  /// In other aspects it is equivalent to \ref NullMap.
+  /// In other aspects it is equivalent to \c NullMap.
   /// So it conforms the \ref concepts::ReadWriteMap "ReadWriteMap"
   /// concept, but it absorbs the data written to it.
@@ -134,7 +134,7 @@
   };
 
-  /// Returns a \ref ConstMap class
-
-  /// This function just returns a \ref ConstMap class.
+  /// Returns a \c ConstMap class
+
+  /// This function just returns a \c ConstMap class.
   /// \relates ConstMap
   template<typename K, typename V>
@@ -157,5 +157,5 @@
   /// value to each key.
   ///
-  /// In other aspects it is equivalent to \ref NullMap.
+  /// In other aspects it is equivalent to \c NullMap.
   /// So it conforms the \ref concepts::ReadWriteMap "ReadWriteMap"
   /// concept, but it absorbs the data written to it.
@@ -183,7 +183,7 @@
   };
 
-  /// Returns a \ref ConstMap class with inlined constant value
-
-  /// This function just returns a \ref ConstMap class with inlined
+  /// Returns a \c ConstMap class with inlined constant value
+
+  /// This function just returns a \c ConstMap class with inlined
   /// constant value.
   /// \relates ConstMap
@@ -213,7 +213,7 @@
   };
 
-  /// Returns an \ref IdentityMap class
-
-  /// This function just returns an \ref IdentityMap class.
+  /// Returns an \c IdentityMap class
+
+  /// This function just returns an \c IdentityMap class.
   /// \relates IdentityMap
   template<typename T>
@@ -229,5 +229,5 @@
   /// values to integer keys from the range <tt>[0..size-1]</tt>.
   /// It can be used with some data structures, for example
-  /// \ref UnionFind, \ref BinHeap, when the used items are small
+  /// \c UnionFind, \c BinHeap, when the used items are small
   /// integers. This map conforms the \ref concepts::ReferenceMap
   /// "ReferenceMap" concept.
@@ -269,5 +269,5 @@
       : _vector(vector.begin(), vector.end()) {}
 
-    /// Constructs the map from another \ref RangeMap.
+    /// Constructs the map from another \c RangeMap.
     template <typename V1>
     RangeMap(const RangeMap<V1> &c)
@@ -312,7 +312,7 @@
   };
 
-  /// Returns a \ref RangeMap class
-
-  /// This function just returns a \ref RangeMap class.
+  /// Returns a \c RangeMap class
+
+  /// This function just returns a \c RangeMap class.
   /// \relates RangeMap
   template<typename V>
@@ -321,8 +321,8 @@
   }
 
-  /// \brief Returns a \ref RangeMap class created from an appropriate
+  /// \brief Returns a \c RangeMap class created from an appropriate
   /// \c std::vector
 
-  /// This function just returns a \ref RangeMap class created from an
+  /// This function just returns a \c RangeMap class created from an
   /// appropriate \c std::vector.
   /// \relates RangeMap
@@ -389,5 +389,5 @@
       : _map(map.begin(), map.end()), _value(value) {}
 
-    /// \brief Constructs the map from another \ref SparseMap.
+    /// \brief Constructs the map from another \c SparseMap.
     template<typename V1, typename Comp1>
     SparseMap(const SparseMap<Key, V1, Comp1> &c)
@@ -434,7 +434,7 @@
   };
 
-  /// Returns a \ref SparseMap class
-
-  /// This function just returns a \ref SparseMap class with specified
+  /// Returns a \c SparseMap class
+
+  /// This function just returns a \c SparseMap class with specified
   /// default value.
   /// \relates SparseMap
@@ -449,8 +449,8 @@
   }
 
-  /// \brief Returns a \ref SparseMap class created from an appropriate
+  /// \brief Returns a \c SparseMap class created from an appropriate
   /// \c std::map
 
-  /// This function just returns a \ref SparseMap class created from an
+  /// This function just returns a \c SparseMap class created from an
   /// appropriate \c std::map.
   /// \relates SparseMap
@@ -502,7 +502,7 @@
   };
 
-  /// Returns a \ref ComposeMap class
-
-  /// This function just returns a \ref ComposeMap class.
+  /// Returns a \c ComposeMap class
+
+  /// This function just returns a \c ComposeMap class.
   ///
   /// If \c m1 and \c m2 are maps and the \c Value type of \c m2 is
@@ -557,7 +557,7 @@
   };
 
-  /// Returns a \ref CombineMap class
-
-  /// This function just returns a \ref CombineMap class.
+  /// Returns a \c CombineMap class
+
+  /// This function just returns a \c CombineMap class.
   ///
   /// For example, if \c m1 and \c m2 are both maps with \c double
@@ -626,7 +626,7 @@
   };
 
-  /// Returns a \ref FunctorToMap class
-
-  /// This function just returns a \ref FunctorToMap class.
+  /// Returns a \c FunctorToMap class
+
+  /// This function just returns a \c FunctorToMap class.
   ///
   /// This function is specialized for adaptable binary function
@@ -685,7 +685,7 @@
   };
 
-  /// Returns a \ref MapToFunctor class
-
-  /// This function just returns a \ref MapToFunctor class.
+  /// Returns a \c MapToFunctor class
+
+  /// This function just returns a \c MapToFunctor class.
   /// \relates MapToFunctor
   template<typename M>
@@ -724,7 +724,7 @@
   };
 
-  /// Returns a \ref ConvertMap class
-
-  /// This function just returns a \ref ConvertMap class.
+  /// Returns a \c ConvertMap class
+
+  /// This function just returns a \c ConvertMap class.
   /// \relates ConvertMap
   template<typename V, typename M>
@@ -764,7 +764,7 @@
   };
 
-  /// Returns a \ref ForkMap class
-
-  /// This function just returns a \ref ForkMap class.
+  /// Returns a \c ForkMap class
+
+  /// This function just returns a \c ForkMap class.
   /// \relates ForkMap
   template <typename M1, typename M2>
@@ -808,7 +808,7 @@
   };
 
-  /// Returns an \ref AddMap class
-
-  /// This function just returns an \ref AddMap class.
+  /// Returns an \c AddMap class
+
+  /// This function just returns an \c AddMap class.
   ///
   /// For example, if \c m1 and \c m2 are both maps with \c double
@@ -856,7 +856,7 @@
   };
 
-  /// Returns a \ref SubMap class
-
-  /// This function just returns a \ref SubMap class.
+  /// Returns a \c SubMap class
+
+  /// This function just returns a \c SubMap class.
   ///
   /// For example, if \c m1 and \c m2 are both maps with \c double
@@ -905,7 +905,7 @@
   };
 
-  /// Returns a \ref MulMap class
-
-  /// This function just returns a \ref MulMap class.
+  /// Returns a \c MulMap class
+
+  /// This function just returns a \c MulMap class.
   ///
   /// For example, if \c m1 and \c m2 are both maps with \c double
@@ -953,7 +953,7 @@
   };
 
-  /// Returns a \ref DivMap class
-
-  /// This function just returns a \ref DivMap class.
+  /// Returns a \c DivMap class
+
+  /// This function just returns a \c DivMap class.
   ///
   /// For example, if \c m1 and \c m2 are both maps with \c double
@@ -1039,7 +1039,7 @@
   };
 
-  /// Returns a \ref ShiftMap class
-
-  /// This function just returns a \ref ShiftMap class.
+  /// Returns a \c ShiftMap class
+
+  /// This function just returns a \c ShiftMap class.
   ///
   /// For example, if \c m is a map with \c double values and \c v is
@@ -1053,7 +1053,7 @@
   }
 
-  /// Returns a \ref ShiftWriteMap class
-
-  /// This function just returns a \ref ShiftWriteMap class.
+  /// Returns a \c ShiftWriteMap class
+
+  /// This function just returns a \c ShiftWriteMap class.
   ///
   /// For example, if \c m is a map with \c double values and \c v is
@@ -1141,7 +1141,7 @@
   };
 
-  /// Returns a \ref ScaleMap class
-
-  /// This function just returns a \ref ScaleMap class.
+  /// Returns a \c ScaleMap class
+
+  /// This function just returns a \c ScaleMap class.
   ///
   /// For example, if \c m is a map with \c double values and \c v is
@@ -1155,7 +1155,7 @@
   }
 
-  /// Returns a \ref ScaleWriteMap class
-
-  /// This function just returns a \ref ScaleWriteMap class.
+  /// Returns a \c ScaleWriteMap class
+
+  /// This function just returns a \c ScaleWriteMap class.
   ///
   /// For example, if \c m is a map with \c double values and \c v is
@@ -1241,7 +1241,7 @@
   };
 
-  /// Returns a \ref NegMap class
-
-  /// This function just returns a \ref NegMap class.
+  /// Returns a \c NegMap class
+
+  /// This function just returns a \c NegMap class.
   ///
   /// For example, if \c m is a map with \c double values, then
@@ -1254,7 +1254,7 @@
   }
 
-  /// Returns a \ref NegWriteMap class
-
-  /// This function just returns a \ref NegWriteMap class.
+  /// Returns a \c NegWriteMap class
+
+  /// This function just returns a \c NegWriteMap class.
   ///
   /// For example, if \c m is a map with \c double values, then
@@ -1297,7 +1297,7 @@
   };
 
-  /// Returns an \ref AbsMap class
-
-  /// This function just returns an \ref AbsMap class.
+  /// Returns an \c AbsMap class
+
+  /// This function just returns an \c AbsMap class.
   ///
   /// For example, if \c m is a map with \c double values, then
@@ -1346,7 +1346,7 @@
   };
 
-  /// Returns a \ref TrueMap class
-
-  /// This function just returns a \ref TrueMap class.
+  /// Returns a \c TrueMap class
+
+  /// This function just returns a \c TrueMap class.
   /// \relates TrueMap
   template<typename K>
@@ -1383,7 +1383,7 @@
   };
 
-  /// Returns a \ref FalseMap class
-
-  /// This function just returns a \ref FalseMap class.
+  /// Returns a \c FalseMap class
+
+  /// This function just returns a \c FalseMap class.
   /// \relates FalseMap
   template<typename K>
@@ -1430,7 +1430,7 @@
   };
 
-  /// Returns an \ref AndMap class
-
-  /// This function just returns an \ref AndMap class.
+  /// Returns an \c AndMap class
+
+  /// This function just returns an \c AndMap class.
   ///
   /// For example, if \c m1 and \c m2 are both maps with \c bool values,
@@ -1478,7 +1478,7 @@
   };
 
-  /// Returns an \ref OrMap class
-
-  /// This function just returns an \ref OrMap class.
+  /// Returns an \c OrMap class
+
+  /// This function just returns an \c OrMap class.
   ///
   /// For example, if \c m1 and \c m2 are both maps with \c bool values,
@@ -1545,7 +1545,7 @@
   };
 
-  /// Returns a \ref NotMap class
-
-  /// This function just returns a \ref NotMap class.
+  /// Returns a \c NotMap class
+
+  /// This function just returns a \c NotMap class.
   ///
   /// For example, if \c m is a map with \c bool values, then
@@ -1558,7 +1558,7 @@
   }
 
-  /// Returns a \ref NotWriteMap class
-
-  /// This function just returns a \ref NotWriteMap class.
+  /// Returns a \c NotWriteMap class
+
+  /// This function just returns a \c NotWriteMap class.
   ///
   /// For example, if \c m is a map with \c bool values, then
@@ -1606,7 +1606,7 @@
   };
 
-  /// Returns an \ref EqualMap class
-
-  /// This function just returns an \ref EqualMap class.
+  /// Returns an \c EqualMap class
+
+  /// This function just returns an \c EqualMap class.
   ///
   /// For example, if \c m1 and \c m2 are maps with keys and values of
@@ -1654,7 +1654,7 @@
   };
 
-  /// Returns an \ref LessMap class
-
-  /// This function just returns an \ref LessMap class.
+  /// Returns an \c LessMap class
+
+  /// This function just returns an \c LessMap class.
   ///
   /// For example, if \c m1 and \c m2 are maps with keys and values of
@@ -1746,7 +1746,7 @@
   };
 
-  /// Returns a \ref LoggerBoolMap class
-
-  /// This function just returns a \ref LoggerBoolMap class.
+  /// Returns a \c LoggerBoolMap class
+
+  /// This function just returns a \c LoggerBoolMap class.
   ///
   /// The most important usage of it is storing certain nodes or arcs
@@ -1768,5 +1768,5 @@
   /// \note LoggerBoolMap is just \ref concepts::WriteMap "writable", so
   /// it cannot be used when a readable map is needed, for example as
-  /// \c ReachedMap for \ref Bfs, \ref Dfs and \ref Dijkstra algorithms.
+  /// \c ReachedMap for \c Bfs, \c Dfs and \c Dijkstra algorithms.
   ///
   /// \relates LoggerBoolMap
@@ -2283,7 +2283,7 @@
   };
 
-  /// \brief Returns a \ref SourceMap class.
-  ///
-  /// This function just returns an \ref SourceMap class.
+  /// \brief Returns a \c SourceMap class.
+  ///
+  /// This function just returns an \c SourceMap class.
   /// \relates SourceMap
   template <typename Digraph>
@@ -2322,7 +2322,7 @@
   };
 
-  /// \brief Returns a \ref TargetMap class.
-  ///
-  /// This function just returns a \ref TargetMap class.
+  /// \brief Returns a \c TargetMap class.
+  ///
+  /// This function just returns a \c TargetMap class.
   /// \relates TargetMap
   template <typename Digraph>
@@ -2361,7 +2361,7 @@
   };
 
-  /// \brief Returns a \ref ForwardMap class.
-  ///
-  /// This function just returns an \ref ForwardMap class.
+  /// \brief Returns a \c ForwardMap class.
+  ///
+  /// This function just returns an \c ForwardMap class.
   /// \relates ForwardMap
   template <typename Graph>
@@ -2400,7 +2400,7 @@
   };
 
-  /// \brief Returns a \ref BackwardMap class
-
-  /// This function just returns a \ref BackwardMap class.
+  /// \brief Returns a \c BackwardMap class
+
+  /// This function just returns a \c BackwardMap class.
   /// \relates BackwardMap
   template <typename Graph>