Index: lemon/bits/vector_map.h
===================================================================
--- lemon/bits/vector_map.h	(revision 280)
+++ lemon/bits/vector_map.h	(revision 314)
@@ -29,21 +29,21 @@
 #include <lemon/concepts/maps.h>
 
-///\ingroup graphbits
-///
-///\file
-///\brief Vector based graph maps.
+//\ingroup graphbits
+//
+//\file
+//\brief Vector based graph maps.
 namespace lemon {
 
-  /// \ingroup graphbits
-  ///
-  /// \brief Graph map based on the std::vector storage.
-  ///
-  /// The VectorMap template class is graph map structure what
-  /// automatically updates the map when a key is added to or erased from
-  /// the map. This map type uses the std::vector to store the values.
-  ///
-  /// \tparam _Graph The graph this map is attached to.
-  /// \tparam _Item The item type of the graph items.
-  /// \tparam _Value The value type of the map.
+  // \ingroup graphbits
+  //
+  // \brief Graph map based on the std::vector storage.
+  //
+  // The VectorMap template class is graph map structure what
+  // automatically updates the map when a key is added to or erased from
+  // the map. This map type uses the std::vector to store the values.
+  //
+  // \tparam _Graph The graph this map is attached to.
+  // \tparam _Item The item type of the graph items.
+  // \tparam _Value The value type of the map.
   template <typename _Graph, typename _Item, typename _Value>
   class VectorMap
@@ -51,39 +51,39 @@
   private:
 
-    /// The container type of the map.
+    // The container type of the map.
     typedef std::vector<_Value> Container;
 
   public:
 
-    /// The graph type of the map.
+    // The graph type of the map.
     typedef _Graph Graph;
-    /// The item type of the map.
+    // The item type of the map.
     typedef _Item Item;
-    /// The reference map tag.
+    // The reference map tag.
     typedef True ReferenceMapTag;
 
-    /// The key type of the map.
+    // The key type of the map.
     typedef _Item Key;
-    /// The value type of the map.
+    // The value type of the map.
     typedef _Value Value;
 
-    /// The notifier type.
+    // The notifier type.
     typedef typename ItemSetTraits<_Graph, _Item>::ItemNotifier Notifier;
 
-    /// The map type.
+    // The map type.
     typedef VectorMap Map;
-    /// The base class of the map.
+    // The base class of the map.
     typedef typename Notifier::ObserverBase Parent;
 
-    /// The reference type of the map;
+    // The reference type of the map;
     typedef typename Container::reference Reference;
-    /// The const reference type of the map;
+    // The const reference type of the map;
     typedef typename Container::const_reference ConstReference;
 
 
-    /// \brief Constructor to attach the new map into the notifier.
-    ///
-    /// It constructs a map and attachs it into the notifier.
-    /// It adds all the items of the graph to the map.
+    // \brief Constructor to attach the new map into the notifier.
+    //
+    // It constructs a map and attachs it into the notifier.
+    // It adds all the items of the graph to the map.
     VectorMap(const Graph& graph) {
       Parent::attach(graph.notifier(Item()));
@@ -91,8 +91,8 @@
     }
 
-    /// \brief Constructor uses given value to initialize the map.
-    ///
-    /// It constructs a map uses a given value to initialize the map.
-    /// It adds all the items of the graph to the map.
+    // \brief Constructor uses given value to initialize the map.
+    //
+    // It constructs a map uses a given value to initialize the map.
+    // It adds all the items of the graph to the map.
     VectorMap(const Graph& graph, const Value& value) {
       Parent::attach(graph.notifier(Item()));
@@ -101,7 +101,7 @@
 
   private:
-    /// \brief Copy constructor
-    ///
-    /// Copy constructor.
+    // \brief Copy constructor
+    //
+    // Copy constructor.
     VectorMap(const VectorMap& _copy) : Parent() {
       if (_copy.attached()) {
@@ -111,11 +111,11 @@
     }
 
-    /// \brief Assign operator.
-    ///
-    /// This operator assigns for each item in the map the
-    /// value mapped to the same item in the copied map.
-    /// The parameter map should be indiced with the same
-    /// itemset because this assign operator does not change
-    /// the container of the map.
+    // \brief Assign operator.
+    //
+    // This operator assigns for each item in the map the
+    // value mapped to the same item in the copied map.
+    // The parameter map should be indiced with the same
+    // itemset because this assign operator does not change
+    // the container of the map.
     VectorMap& operator=(const VectorMap& cmap) {
       return operator=<VectorMap>(cmap);
@@ -123,10 +123,10 @@
 
 
-    /// \brief Template assign operator.
-    ///
-    /// The given parameter should be conform to the ReadMap
-    /// concecpt and could be indiced by the current item set of
-    /// the NodeMap. In this case the value for each item
-    /// is assigned by the value of the given ReadMap.
+    // \brief Template assign operator.
+    //
+    // The given parameter should be conform to the ReadMap
+    // concecpt and could be indiced by the current item set of
+    // the NodeMap. In this case the value for each item
+    // is assigned by the value of the given ReadMap.
     template <typename CMap>
     VectorMap& operator=(const CMap& cmap) {
@@ -142,16 +142,16 @@
   public:
 
-    /// \brief The subcript operator.
-    ///
-    /// The subscript operator. The map can be subscripted by the
-    /// actual items of the graph.
+    // \brief The subcript operator.
+    //
+    // The subscript operator. The map can be subscripted by the
+    // actual items of the graph.
     Reference operator[](const Key& key) {
       return container[Parent::notifier()->id(key)];
     }
 
-    /// \brief The const subcript operator.
-    ///
-    /// The const subscript operator. The map can be subscripted by the
-    /// actual items of the graph.
+    // \brief The const subcript operator.
+    //
+    // The const subscript operator. The map can be subscripted by the
+    // actual items of the graph.
     ConstReference operator[](const Key& key) const {
       return container[Parent::notifier()->id(key)];
@@ -159,7 +159,7 @@
 
 
-    /// \brief The setter function of the map.
-    ///
-    /// It the same as operator[](key) = value expression.
+    // \brief The setter function of the map.
+    //
+    // It the same as operator[](key) = value expression.
     void set(const Key& key, const Value& value) {
       (*this)[key] = value;
@@ -168,8 +168,8 @@
   protected:
 
-    /// \brief Adds a new key to the map.
-    ///
-    /// It adds a new key to the map. It called by the observer notifier
-    /// and it overrides the add() member function of the observer base.
+    // \brief Adds a new key to the map.
+    //
+    // It adds a new key to the map. It called by the observer notifier
+    // and it overrides the add() member function of the observer base.
     virtual void add(const Key& key) {
       int id = Parent::notifier()->id(key);
@@ -179,8 +179,8 @@
     }
 
-    /// \brief Adds more new keys to the map.
-    ///
-    /// It adds more new keys to the map. It called by the observer notifier
-    /// and it overrides the add() member function of the observer base.
+    // \brief Adds more new keys to the map.
+    //
+    // It adds more new keys to the map. It called by the observer notifier
+    // and it overrides the add() member function of the observer base.
     virtual void add(const std::vector<Key>& keys) {
       int max = container.size() - 1;
@@ -194,16 +194,16 @@
     }
 
-    /// \brief Erase a key from the map.
-    ///
-    /// Erase a key from the map. It called by the observer notifier
-    /// and it overrides the erase() member function of the observer base.
+    // \brief Erase a key from the map.
+    //
+    // Erase a key from the map. It called by the observer notifier
+    // and it overrides the erase() member function of the observer base.
     virtual void erase(const Key& key) {
       container[Parent::notifier()->id(key)] = Value();
     }
 
-    /// \brief Erase more keys from the map.
-    ///
-    /// Erase more keys from the map. It called by the observer notifier
-    /// and it overrides the erase() member function of the observer base.
+    // \brief Erase more keys from the map.
+    //
+    // Erase more keys from the map. It called by the observer notifier
+    // and it overrides the erase() member function of the observer base.
     virtual void erase(const std::vector<Key>& keys) {
       for (int i = 0; i < int(keys.size()); ++i) {
@@ -212,8 +212,8 @@
     }
 
-    /// \brief Buildes the map.
-    ///
-    /// It buildes the map. It called by the observer notifier
-    /// and it overrides the build() member function of the observer base.
+    // \brief Buildes the map.
+    //
+    // It buildes the map. It called by the observer notifier
+    // and it overrides the build() member function of the observer base.
     virtual void build() {
       int size = Parent::notifier()->maxId() + 1;
@@ -222,8 +222,8 @@
     }
 
-    /// \brief Clear the map.
-    ///
-    /// It erase all items from the map. It called by the observer notifier
-    /// and it overrides the clear() member function of the observer base.
+    // \brief Clear the map.
+    //
+    // It erase all items from the map. It called by the observer notifier
+    // and it overrides the clear() member function of the observer base.
     virtual void clear() {
       container.clear();