Index: doc/Doxyfile.in
===================================================================
--- doc/Doxyfile.in	(revision 299)
+++ doc/Doxyfile.in	(revision 316)
@@ -1,3 +1,3 @@
-# Doxyfile 1.5.5
+# Doxyfile 1.5.7.1
 
 #---------------------------------------------------------------------------
@@ -34,7 +34,9 @@
 CPP_CLI_SUPPORT        = NO
 SIP_SUPPORT            = NO
+IDL_PROPERTY_SUPPORT   = YES
 DISTRIBUTE_GROUP_DOC   = NO
 SUBGROUPING            = YES
 TYPEDEF_HIDES_STRUCT   = NO
+SYMBOL_CACHE_SIZE      = 0
 #---------------------------------------------------------------------------
 # Build related configuration options
@@ -67,5 +69,8 @@
 SHOW_USED_FILES        = YES
 SHOW_DIRECTORIES       = YES
+SHOW_FILES             = YES
+SHOW_NAMESPACES        = YES
 FILE_VERSION_FILTER    = 
+LAYOUT_FILE            = DoxygenLayout.xml
 #---------------------------------------------------------------------------
 # configuration options related to warning and progress messages
@@ -76,5 +81,5 @@
 WARN_IF_DOC_ERROR      = YES
 WARN_NO_PARAMDOC       = NO
-WARN_FORMAT            = "$file:$line: $text  "
+WARN_FORMAT            = "$file:$line: $text"
 WARN_LOGFILE           = doxygen.log
 #---------------------------------------------------------------------------
@@ -134,18 +139,25 @@
 HTML_STYLESHEET        = 
 HTML_ALIGN_MEMBERS     = YES
-GENERATE_HTMLHELP      = NO
+HTML_DYNAMIC_SECTIONS  = NO
 GENERATE_DOCSET        = NO
 DOCSET_FEEDNAME        = "Doxygen generated docs"
 DOCSET_BUNDLE_ID       = org.doxygen.Project
-HTML_DYNAMIC_SECTIONS  = NO
+GENERATE_HTMLHELP      = NO
 CHM_FILE               = 
 HHC_LOCATION           = 
 GENERATE_CHI           = NO
+CHM_INDEX_ENCODING     = 
 BINARY_TOC             = NO
 TOC_EXPAND             = NO
+GENERATE_QHP           = NO
+QCH_FILE               = 
+QHP_NAMESPACE          = org.doxygen.Project
+QHP_VIRTUAL_FOLDER     = doc
+QHG_LOCATION           = 
 DISABLE_INDEX          = NO
 ENUM_VALUES_PER_LINE   = 4
 GENERATE_TREEVIEW      = NO
 TREEVIEW_WIDTH         = 250
+FORMULA_FONTSIZE       = 10
 #---------------------------------------------------------------------------
 # configuration options related to the LaTeX output
@@ -226,4 +238,7 @@
 HIDE_UNDOC_RELATIONS   = YES
 HAVE_DOT               = YES
+DOT_FONTNAME           = FreeSans
+DOT_FONTSIZE           = 10
+DOT_FONTPATH           = 
 CLASS_GRAPH            = YES
 COLLABORATION_GRAPH    = NO
Index: doc/DoxygenLayout.xml
===================================================================
--- doc/DoxygenLayout.xml	(revision 316)
+++ doc/DoxygenLayout.xml	(revision 316)
@@ -0,0 +1,182 @@
+<doxygenlayout version="1.0">
+  <!-- Navigation index tabs for HTML output -->
+  <navindex>
+    <tab type="mainpage" visible="yes" title=""/>
+    <tab type="modules" visible="yes" title=""/>
+    <tab type="classes" visible="yes" title="">
+      <tab type="classes" visible="yes" title=""/>
+      <tab type="classindex" visible="$ALPHABETICAL_INDEX" title=""/> 
+      <tab type="hierarchy" visible="yes" title=""/>
+      <tab type="classmembers" visible="yes" title=""/>
+    </tab>
+    <tab type="namespaces" visible="yes" title="">
+      <tab type="namespaces" visible="yes" title=""/>
+      <tab type="namespacemembers" visible="yes" title=""/>
+    </tab>
+    <tab type="files" visible="yes" title="">
+      <tab type="files" visible="yes" title=""/>
+      <tab type="globals" visible="yes" title=""/>
+    </tab>
+    <tab type="dirs" visible="yes" title=""/>
+    <tab type="examples" visible="yes" title=""/>  
+    <tab type="pages" visible="yes" title=""/>
+  </navindex>
+
+  <!-- Layout definition for a class page -->
+  <class>
+    <briefdescription visible="no"/>
+    <detaileddescription title=""/>
+    <includes visible="$SHOW_INCLUDE_FILES"/>
+    <inheritancegraph visible="$CLASS_GRAPH"/>
+    <collaborationgraph visible="$COLLABORATION_GRAPH"/>
+    <allmemberslink visible="yes"/>
+    <memberdecl>
+      <membergroups visible="yes"/>
+      <nestedclasses visible="yes" title=""/>
+      <publictypes title=""/>
+      <publicslots title=""/>
+      <signals title=""/>
+      <publicmethods title=""/>
+      <publicstaticmethods title=""/>
+      <publicattributes title=""/>
+      <publicstaticattributes title=""/>
+      <protectedtypes title=""/>
+      <protectedslots title=""/>
+      <protectedmethods title=""/>
+      <protectedstaticmethods title=""/>
+      <protectedattributes title=""/>
+      <protectedstaticattributes title=""/>
+      <packagetypes title=""/>
+      <packagemethods title=""/>
+      <packagestaticmethods title=""/>
+      <packageattributes title=""/>
+      <packagestaticattributes title=""/>
+      <properties title=""/>
+      <events title=""/>
+      <privatetypes title=""/>
+      <privateslots title=""/>
+      <privatemethods title=""/>
+      <privatestaticmethods title=""/>
+      <privateattributes title=""/>
+      <privatestaticattributes title=""/>
+      <friends title=""/>
+      <related title="" subtitle=""/>
+    </memberdecl>
+    <memberdef>
+      <typedefs title=""/>
+      <enums title=""/>
+      <constructors title=""/>
+      <functions title=""/>
+      <related title=""/>
+      <variables title=""/>
+      <properties title=""/>
+      <events title=""/>
+    </memberdef>
+    <usedfiles visible="$SHOW_USED_FILES"/>
+    <authorsection visible="yes"/>
+  </class>
+
+  <!-- Layout definition for a namespace page -->
+  <namespace>
+    <briefdescription visible="no"/>
+    <detaileddescription title=""/>
+    <memberdecl>
+      <nestednamespaces visible="yes" title=""/>
+      <classes visible="yes" title=""/>
+      <membergroups visible="yes"/>
+      <typedefs title=""/>
+      <enums title=""/>
+      <functions title=""/>
+      <variables title=""/>
+    </memberdecl>
+    <memberdef>
+      <typedefs title=""/>
+      <enums title=""/>
+      <functions title=""/>
+      <variables title=""/>
+    </memberdef>
+    <authorsection visible="yes"/>
+  </namespace>
+
+  <!-- Layout definition for a file page -->
+  <file>
+    <briefdescription visible="no"/>
+    <detaileddescription title=""/>
+    <includes visible="$SHOW_INCLUDE_FILES"/>
+    <includegraph visible="$INCLUDE_GRAPH"/>
+    <includedbygraph visible="$INCLUDED_BY_GRAPH"/>
+    <sourcelink visible="yes"/>
+    <memberdecl>
+      <classes visible="yes" title=""/>
+      <namespaces visible="yes" title=""/>
+      <defines title=""/>
+      <typedefs title=""/>
+      <enums title=""/>
+      <functions title=""/>
+      <variables title=""/>
+    </memberdecl>
+    <memberdef>
+      <defines title=""/>
+      <typedefs title=""/>
+      <enums title=""/>
+      <functions title=""/>
+      <variables title=""/>
+    </memberdef>
+    <authorsection/>
+  </file>
+
+  <!-- Layout definition for a group page -->
+  <group>
+    <briefdescription visible="no"/>
+    <detaileddescription title=""/>
+    <groupgraph visible="$GROUP_GRAPHS"/>
+    <memberdecl>
+      <classes visible="yes" title=""/>
+      <namespaces visible="yes" title=""/>
+      <dirs visible="yes" title=""/>
+      <nestedgroups visible="yes" title=""/>
+      <files visible="yes" title=""/>
+      <defines title=""/>
+      <typedefs title=""/>
+      <enums title=""/>
+      <enumvalues title=""/>
+      <functions title=""/>
+      <variables title=""/>
+      <signals title=""/>
+      <publicslots title=""/>
+      <protectedslots title=""/>
+      <privateslots title=""/>
+      <events title=""/>
+      <properties title=""/>
+      <friends title=""/>
+    </memberdecl>
+    <memberdef>
+      <pagedocs/>
+      <defines title=""/>
+      <typedefs title=""/>
+      <enums title=""/>
+      <enumvalues title=""/>
+      <functions title=""/>
+      <variables title=""/>
+      <signals title=""/>
+      <publicslots title=""/>
+      <protectedslots title=""/>
+      <privateslots title=""/>
+      <events title=""/>
+      <properties title=""/>
+      <friends title=""/>
+    </memberdef>
+    <authorsection visible="yes"/>
+  </group>
+
+  <!-- Layout definition for a directory page -->
+  <directory>
+    <briefdescription visible="no"/>
+    <detaileddescription title=""/>
+    <directorygraph visible="yes"/>
+    <memberdecl>
+      <dirs visible="yes"/>
+      <files visible="yes"/>
+    </memberdecl>
+  </directory>
+</doxygenlayout>
Index: doc/Makefile.am
===================================================================
--- doc/Makefile.am	(revision 306)
+++ doc/Makefile.am	(revision 316)
@@ -1,4 +1,5 @@
 EXTRA_DIST += \
 	doc/Doxyfile.in \
+	doc/DoxygenLayout.xml \
 	doc/coding_style.dox \
 	doc/dirs.dox \
@@ -7,5 +8,4 @@
 	doc/license.dox \
 	doc/mainpage.dox \
-	doc/migration.dox \
 	doc/named-param.dox \
 	doc/namespaces.dox \
Index: doc/groups.dox
===================================================================
--- doc/groups.dox	(revision 314)
+++ doc/groups.dox	(revision 236)
@@ -55,7 +55,5 @@
 You are free to use the graph structure that fit your requirements
 the best, most graph algorithms and auxiliary data structures can be used
-with any graph structure.
-
-<b>See also:</b> \ref graph_concepts "Graph Structure Concepts".
+with any graph structures.
 */
 
@@ -77,8 +75,6 @@
 This group describes the map structures implemented in LEMON.
 
-LEMON provides several special purpose maps and map adaptors that e.g. combine
+LEMON provides several special purpose maps that e.g. combine
 new maps from existing ones.
-
-<b>See also:</b> \ref map_concepts "Map Concepts".
 */
 
@@ -91,4 +87,5 @@
 values to the nodes and arcs of graphs.
 */
+
 
 /**
@@ -108,5 +105,5 @@
 algorithms.  If a function type algorithm is called then the function
 type map adaptors can be used comfortable. For example let's see the
-usage of map adaptors with the \c graphToEps() function.
+usage of map adaptors with the \c digraphToEps() function.
 \code
   Color nodeColor(int deg) {
@@ -122,5 +119,5 @@
   Digraph::NodeMap<int> degree_map(graph);
 
-  graphToEps(graph, "graph.eps")
+  digraphToEps(graph, "graph.eps")
     .coords(coords).scaleToA4().undirected()
     .nodeColors(composeMap(functorToMap(nodeColor), degree_map))
@@ -128,5 +125,5 @@
 \endcode
 The \c functorToMap() function makes an \c int to \c Color map from the
-\c nodeColor() function. The \c composeMap() compose the \c degree_map
+\e nodeColor() function. The \c composeMap() compose the \e degree_map
 and the previously created map. The composed map is a proper function to
 get the color of each node.
@@ -177,4 +174,5 @@
 
 \sa lemon::concepts::Path
+
 */
 
@@ -188,4 +186,5 @@
 */
 
+
 /**
 @defgroup algs Algorithms
@@ -203,9 +202,9 @@
 
 This group describes the common graph search algorithms like
-Breadth-First Search (BFS) and Depth-First Search (DFS).
-*/
-
-/**
-@defgroup shortest_path Shortest Path Algorithms
+Breadth-first search (Bfs) and Depth-first search (Dfs).
+*/
+
+/**
+@defgroup shortest_path Shortest Path algorithms
 @ingroup algs
 \brief Algorithms for finding shortest paths.
@@ -215,5 +214,5 @@
 
 /**
-@defgroup max_flow Maximum Flow Algorithms
+@defgroup max_flow Maximum Flow algorithms
 @ingroup algs
 \brief Algorithms for finding maximum flows.
@@ -243,8 +242,9 @@
 provides functions to query the minimum cut, which is the dual linear
 programming problem of the maximum flow.
-*/
-
-/**
-@defgroup min_cost_flow Minimum Cost Flow Algorithms
+
+*/
+
+/**
+@defgroup min_cost_flow Minimum Cost Flow algorithms
 @ingroup algs
 
@@ -256,5 +256,5 @@
 
 /**
-@defgroup min_cut Minimum Cut Algorithms
+@defgroup min_cut Minimum Cut algorithms
 @ingroup algs
 
@@ -283,8 +283,9 @@
 If you want to find minimum cut just between two distinict nodes,
 please see the \ref max_flow "Maximum Flow page".
-*/
-
-/**
-@defgroup graph_prop Connectivity and Other Graph Properties
+
+*/
+
+/**
+@defgroup graph_prop Connectivity and other graph properties
 @ingroup algs
 \brief Algorithms for discovering the graph properties
@@ -298,5 +299,5 @@
 
 /**
-@defgroup planar Planarity Embedding and Drawing
+@defgroup planar Planarity embedding and drawing
 @ingroup algs
 \brief Algorithms for planarity checking, embedding and drawing
@@ -310,5 +311,5 @@
 
 /**
-@defgroup matching Matching Algorithms
+@defgroup matching Matching algorithms
 @ingroup algs
 \brief Algorithms for finding matchings in graphs and bipartite graphs.
@@ -348,8 +349,9 @@
 \image html bipartite_matching.png
 \image latex bipartite_matching.eps "Bipartite Matching" width=\textwidth
-*/
-
-/**
-@defgroup spantree Minimum Spanning Tree Algorithms
+
+*/
+
+/**
+@defgroup spantree Minimum Spanning Tree algorithms
 @ingroup algs
 \brief Algorithms for finding a minimum cost spanning tree in a graph.
@@ -359,6 +361,7 @@
 */
 
-/**
-@defgroup auxalg Auxiliary Algorithms
+
+/**
+@defgroup auxalg Auxiliary algorithms
 @ingroup algs
 \brief Auxiliary algorithms implemented in LEMON.
@@ -369,6 +372,5 @@
 
 /**
-@defgroup approx Approximation Algorithms
-@ingroup algs
+@defgroup approx Approximation algorithms
 \brief Approximation algorithms.
 
@@ -384,8 +386,9 @@
 This group describes some general optimization frameworks
 implemented in LEMON.
-*/
-
-/**
-@defgroup lp_group Lp and Mip Solvers
+
+*/
+
+/**
+@defgroup lp_group Lp and Mip solvers
 @ingroup gen_opt_group
 \brief Lp and Mip solver interfaces for LEMON.
@@ -394,8 +397,9 @@
 various LP solvers could be used in the same manner with this
 interface.
-*/
-
-/**
-@defgroup lp_utils Tools for Lp and Mip Solvers
+
+*/
+
+/**
+@defgroup lp_utils Tools for Lp and Mip solvers
 @ingroup lp_group
 \brief Helper tools to the Lp and Mip solvers.
@@ -438,5 +442,5 @@
 
 /**
-@defgroup timecount Time Measuring and Counting
+@defgroup timecount Time measuring and Counting
 @ingroup misc
 \brief Simple tools for measuring the performance of algorithms.
@@ -444,4 +448,13 @@
 This group describes simple tools for measuring the performance
 of algorithms.
+*/
+
+/**
+@defgroup graphbits Tools for Graph Implementation
+@ingroup utils
+\brief Tools to make it easier to create graphs.
+
+This group describes the tools that makes it easier to create graphs and
+the maps that dynamically update with the graph changes.
 */
 
@@ -459,7 +472,6 @@
 
 This group describes the tools for importing and exporting graphs
-and graph related data. Now it supports the \ref lgf-format
-"LEMON Graph Format", the \c DIMACS format and the encapsulated
-postscript (EPS) format.
+and graph related data. Now it supports the LEMON format, the
+\c DIMACS format and the encapsulated postscript (EPS) format.
 */
 
@@ -467,5 +479,5 @@
 @defgroup lemon_io LEMON Input-Output
 @ingroup io_group
-\brief Reading and writing LEMON Graph Format.
+\brief Reading and writing \ref lgf-format "LEMON Graph Format".
 
 This group describes methods for reading and writing
@@ -474,5 +486,5 @@
 
 /**
-@defgroup eps_io Postscript Exporting
+@defgroup eps_io Postscript exporting
 @ingroup io_group
 \brief General \c EPS drawer and graph exporter
@@ -481,4 +493,5 @@
 graph exporting tools.
 */
+
 
 /**
@@ -509,5 +522,7 @@
 
 - Finally, They can serve as a skeleton of a new implementation of a concept.
-*/
+
+*/
+
 
 /**
@@ -520,10 +535,8 @@
 */
 
-/**
-@defgroup map_concepts Map Concepts
-@ingroup concept
-\brief Skeleton and concept checking classes for maps
-
-This group describes the skeletons and concept checking classes of maps.
+/* --- Unused group
+@defgroup experimental Experimental Structures and Algorithms
+This group describes some Experimental structures and algorithms.
+The stuff here is subject to change.
 */
 
Index: doc/lgf.dox
===================================================================
--- doc/lgf.dox	(revision 313)
+++ doc/lgf.dox	(revision 236)
@@ -79,5 +79,5 @@
 \endcode
 
-The \c \@edges is just a synonym of \c \@arcs. The \@arcs section can
+The \c \@edges is just a synonym of \c \@arcs. The @arcs section can
 also store the edge set of an undirected graph. In such case there is
 a conventional method for store arc maps in the file, if two columns
Index: doc/mainpage.dox
===================================================================
--- doc/mainpage.dox	(revision 314)
+++ doc/mainpage.dox	(revision 209)
@@ -51,5 +51,5 @@
 If you
 want to see how LEMON works, see
-some \ref demoprograms "demo programs".
+some \ref demoprograms "demo programs"!
 
 If you know what you are looking for then try to find it under the
@@ -57,5 +57,4 @@
 section.
 
-If you are a user of the old (0.x) series of LEMON, please check out the
-\ref migration "Migration Guide" for the backward incompatibilities.
+
 */
Index: doc/migration.dox
===================================================================
--- doc/migration.dox	(revision 314)
+++ 	(revision )
@@ -1,143 +1,0 @@
-/* -*- mode: C++; indent-tabs-mode: nil; -*-
- *
- * This file is a part of LEMON, a generic C++ optimization library.
- *
- * Copyright (C) 2003-2008
- * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Research Group on Combinatorial Optimization, EGRES).
- *
- * Permission to use, modify and distribute this software is granted
- * provided that this copyright notice appears in all copies. For
- * precise terms see the accompanying LICENSE file.
- *
- * This software is provided "AS IS" with no warranty of any kind,
- * express or implied, and with no claim as to its suitability for any
- * purpose.
- *
- */
-
-namespace lemon {
-/*!
-
-\page migration Migration from the 0.x Series
-
-This guide gives an in depth description on what has changed compared
-to the 0.x release series.
-
-Many of these changes adjusted automatically by the
-<tt>script/lemon-0.x-to-1.x.sh</tt> tool. Those requiring manual
-update are typeset <b>boldface</b>.
-
-\section migration-graph Graph Related Name Changes
-
-- \ref concepts::Digraph "Directed graphs" are called \c Digraph and
-  they have <tt>Arc</tt>s (instead of <tt>Edge</tt>s), while
-  \ref concepts::Graph "undirected graphs" are called \c Graph
-  (instead of \c UGraph) and they have <tt>Edge</tt>s (instead of
-  <tt>UEdge</tt>s). These changes reflected thoroughly everywhere in
-  the library. Namely,
-  - \c Graph -> \c Digraph
-    - \c %ListGraph -> \c ListDigraph, \c %SmartGraph -> \c SmartDigraph etc.
-  - \c UGraph -> \c Graph
-    - \c ListUGraph -> \c ListGraph, \c SmartUGraph -> \c SmartGraph etc.
-  - \c Edge -> \c Arc, \c UEdge -> \c Edge
-  - \c EdgeMap -> \c ArcMap, \c UEdgeMap -> \c EdgeMap
-  - \c EdgeIt -> \c ArcIt, \c UEdgeIt -> \c EdgeIt
-  - Class names and function names containing the words \c graph,
-    \c ugraph, \e edge or \e arc should also be updated.
-- <b>The two endpoints of an (\e undirected) \c Edge can be obtained by the
-  <tt>u()</tt> and <tt>v()</tt> member function of the graph
-  (instead of <tt>source()</tt> and <tt>target()</tt>). This change
-  must be done by hand.</b>
-  \n Of course, you can still use <tt>source()</tt> and <tt>target()</tt>
-  for <tt>Arc</tt>s (directed edges).
-
-\warning
-<b>The <tt>script/lemon-0.x-to-1.x.sh</tt> tool replaces all instances of
-the words \c graph, \c digraph, \c edge and \c arc, so it replaces them
-in strings, comments etc. as well as in all identifiers.</b>
-
-\section migration-lgf LGF tools
- - The \ref lgf-format "LGF file format" has changed,
-   <tt>\@nodeset</tt> has changed to <tt>\@nodes</tt>,
-   <tt>\@edgeset</tt> and <tt>\@uedgeset</tt> to <tt>\@arcs</tt> or
-   <tt>\@edges</tt>, which become completely equivalents. The
-   <tt>\@nodes</tt>, <tt>\@edges</tt> and <tt>\@uedges</tt> sections are
-   removed from the format, the content of them should be
-   the part of <tt>\@attributes</tt> section. The data fields in
-   the sections must follow a strict format, they must be either character
-   sequences without whitespaces or quoted strings.
- - The <tt>LemonReader</tt> and <tt>LemonWriter</tt> core interfaces
-   are no longer available.
- - The implementation of the general section readers and writers has changed
-   they are simple functors now. Beside the old
-   stream based section handling, currently line oriented section
-   reading and writing are also supported. In the
-   section readers the lines must be counted manually. The sections
-   should be read and written with the SectionWriter and SectionReader
-   classes.
- - Instead of the item readers and writers, item converters should be
-   used. The converters are functors, which map the type to
-   std::string or std::string to the type. The converters for standard
-   containers hasn't yet been implemented in the new LEMON. The converters
-   can return strings in any format, because if it is necessary, the LGF
-   writer and reader will quote and unquote the given value.
- - The DigraphReader and DigraphWriter can used similarly to the
-   0.x series, however the <tt>read</tt> or <tt>write</tt> prefix of
-   the member functions are removed.
- - The new LEMON supports the function like interface, the \c
-   digraphReader and \c digraphWriter functions are more convenient than
-   using the classes directly.
-
-\section migration-search BFS, DFS and Dijkstra
-- <b>Using the function interface of BFS, DFS and %Dijkstra both source and
-  target nodes can be given as parameters of the <tt>run()</tt> function
-  (instead of \c bfs(), \c dfs() or \c dijkstra() itself).</b>
-- \ref named-templ-param "Named class template parameters" of \c Bfs,
-  \c Dfs, \c Dijkstra, \c BfsVisit, \c DfsVisit are renamed to start
-  with "Set" instead of "Def". Namely,
-  - \c DefPredMap -> \c SetPredMap
-  - \c DefDistMap -> \c SetDistMap
-  - \c DefReachedMap -> \c SetReachedMap
-  - \c DefProcessedMap -> \c SetProcessedMap
-  - \c DefHeap -> \c SetHeap
-  - \c DefStandardHeap -> \c SetStandardHeap
-  - \c DefOperationTraits -> \c SetOperationTraits
-  - \c DefProcessedMapToBeDefaultMap -> \c SetStandardProcessedMap
-
-\section migration-error Exceptions and Debug tools
-
-<b>The class hierarchy of exceptions has largely been simplified. Now,
-only the i/o related tools may throw exceptions. All other exceptions
-have been replaced with either the \c LEMON_ASSERT or the \c LEMON_DEBUG
-macros.</b>
-
-<b>On the other hand, the parameter order of constructors of the
-exceptions has been changed. See \ref IoError and \ref FormatError for
-more details.</b>
-
-\section migration-other Others
-- <b>The contents of <tt>graph_utils.h</tt> are moved to <tt>core.h</tt>
-  and <tt>maps.h</tt>. <tt>core.h</tt> is included by all graph types,
-  therefore it usually do not have to be included directly.</b>
-- <b><tt>path_utils.h</tt> is merged to \c path.h.</b>
-- <b>The semantic of the assignment operations and copy constructors of maps
-  are still under discussion. So, you must copy them by hand (i.e. copy
-  each entry one-by-one)</b>
-- <b>The parameters of the graph copying tools (i.e. \c GraphCopy,
-  \c DigraphCopy) have to be given in the from-to order.</b>
-- \c copyDigraph() and \c copyGraph() are renamed to \c digraphCopy()
-  and \c graphCopy(), respectively.
-- <b>The interface of \ref DynArcLookUp has changed. It is now the same as
-  of \ref ArcLookUp and \ref AllArcLookUp</b>
-- Some map types should also been renamed. Namely,
-  - \c IntegerMap -> \c RangeMap
-  - \c StdMap -> \c SparseMap
-  - \c FunctorMap -> \c FunctorToMap
-  - \c MapFunctor -> \c MapToFunctor
-  - \c ForkWriteMap -> \c ForkMap
-  - \c StoreBoolMap -> \c LoggerBoolMap
-- \c dim2::BoundingBox -> \c dim2::Box
-
-*/
-}